import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.math.BigInteger;

public class aufgabe_1_3 extends Applet
{
	TextArea	input_z1 = new TextArea("" , 2 , 40 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextArea	input_z2 = new TextArea("" , 2 , 40 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextArea	output_str = new TextArea("" , 2 , 40 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	
	BigInteger	gcd(BigInteger z1 , BigInteger z2)
	{
		BigInteger	z3;
		boolean		sign = false;

		//BigInteger.mod kann anscheinend keine negativen Zahlen verarbeiten,
		//also mit Betrag arbeiten und Vorzeichen zum Schluss wieder draufhauen
		if (z1.signum() == -1)
		{
			sign = true;
			z1 = z1.negate();
		}
		if (z2.signum() == -1)
		{
			sign = true;
			z2 = z2.negate();
		}

		if (z1.equals(BigInteger.valueOf(0)) || z2.equals(BigInteger.valueOf(0)))
			return BigInteger.valueOf(0);
		
		//lasse z1 die groessere der beiden Zahlen sein
		if (z1.compareTo(z2)<0)
		{
			z3=z1;
			z1=z2;
			z2=z3;
		}
		
		do
		{
			z3 = z1.mod(z2);
			z1 = z2;
			z2 = z3;
		}
		while (z3.equals(BigInteger.valueOf(0)) == false);
		
		if (sign == true)
			z1 = z1.negate();

		return z1;
	}
	
	public void init()
	{
		setFont(new Font("Courier" , Font.BOLD , 12));

		Button	button = new Button("ggT(Zahl 1 , Zahl 2)");
		button.setActionCommand("gcd");

		setLayout(new GridLayout(6,1));
		add(new Label("Zahl 1 : "));
		add(input_z1);		
		add(new Label("Zahl 2 : "));
		add(input_z2);
		add(button);
		add(output_str);
		
		
		ActionListener action = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String	cmd = e.getActionCommand();
				if (cmd == "gcd")
				{
					String		str1,str2;
					BigInteger	z1,z2,z3;
					
					str1 = input_z1.getText();
					if (str1.charAt(0)=='+')
						str1 = str1.substring(1,str1.length());
					try
					{
						z1 = new BigInteger(str1);

						str2 = input_z2.getText();
						if (str2.charAt(0)=='+')
							str2 = str2.substring(1,str2.length());
						try
						{
							z2 = new BigInteger(str2);
							z3 = gcd(z1,z2);
							output_str.setText(z3.toString());
						}
						catch (NumberFormatException error)
						{
							output_str.setText("Error : "+error.getMessage());
						}
						
					}
					catch (NumberFormatException error)
					{
						output_str.setText("Error : "+error.getMessage());
					}

				}
			}
		};
		
		button.addActionListener(action);
	}
	
	public void start()
	{	repaint();	}
	
	public void run()
	{	repaint();	}
	
	public void paint(Graphics g)
	{
	}
	
	public void destroy()
	{
	}
}