import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.math.BigInteger;

//BIGINTEGER liefert schon die g-adischen Methoden

public class aufgabe_1_1 extends Applet
{
	TextField	input_number = new TextField("" , 20);
	TextField	input_base = new TextField("" , 10);
	TextArea	output = new TextArea("" , 5 , 40 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextArea	output2 = new TextArea("" , 5 , 40 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	
	public void HornerScheme(BigInteger n , BigInteger b)
	{
		String		str = "";
		int			i , count;
		BigInteger	n2;
		BigInteger	nums[];

		//Anzahl der Stellen bestimmen um das array nums[] fuer die
		//Ziffern-Wertigkeiten zu initialisieren
		count=0;
		n2 = n;
		do
		{
			n2 = n2.divide(b);
			count++;
		}
		while (n2.equals(BigInteger.valueOf(0)) == false);
		
		nums = new BigInteger[count];
		
		//Ziffern-Wertigkeiten in array nums[] speichern
		i=0;
		do
		{
			n2 = n.mod(b);
			n = n.divide(b);
			nums[i]=n2;
			i++;
		}
		while (n.equals(BigInteger.valueOf(0)) == false);

		//und die Zahl in einen String umwandeln (Summendarstellung)
		str = "";
		for (i=count-1; i>=0; i--)
		{
			str += nums[i].toString()+'*'+b.toString()+"^"+Integer.toString(i);
			if (i>0)
				str += "  +  ";
		}

		output.setText(str);
		
		//Falls Basis <=16 , dies noch gesondert anzeigen ("0123456789ABCDEF")
		str = "";
		if (b.intValue() <=16)
		{
			char	c[] = new char[count];
			
			for (i=0; i<count; i++)
			{
				c[i]=(char)nums[count-1-i].intValue();
				if ((c[i]>=0) && (c[i]<=9))
					c[i]+='0';
				else
					c[i]+='A'-10;
				//str = new String(c);
				str += c[i];
			}
			output2.setText(str);
		}
		else
			output2.setText("");
	}


	public void init()
	{
		setFont(new Font("Courier" , Font.BOLD , 12));
		
		Button		button = new Button("Zahl umwandeln");
		button.setActionCommand("Zahl umwandeln");

		Panel	panel = new Panel();
		panel.setLayout(new GridLayout(4,2,6,6));
		panel.add(new Label("natrliche Zahl : "));
		panel.add(input_number);
		panel.add(new Label("Basis : "));
		panel.add(input_base);
		panel.add(new Label(""));
		panel.add(button);
		panel.add(new Label("g-adische Darstellung :"));
		
		setLayout(new GridLayout(5,1));
		add(panel);
		add(output);
		add(new Label("bliche Darstellung (nur bis maximal Basis=16) : "));
		add(output2);

		ActionListener	action = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String	str;
				String	cmd = e.getActionCommand();
				
				if (cmd == "Zahl umwandeln")
				{
					try
					{
						//fuehrendes '+' zulassen
						str = input_number.getText();
						if (str.charAt(0) == '+')
							str = str.substring(1,str.length());
						
						//Zahl lesen
						BigInteger n = new BigInteger(str, 10);

						//Pruefen, ob natuerliche Zahl eingegeben wurde
						if (n.compareTo(BigInteger.valueOf(0)) < 0)
							throw new NumberFormatException("only accepting positive integers");

						//Basis lesen
						try
						{
							//fuehrendes '+' zulassen
							str = input_base.getText();
							if (str.charAt(0) == '+')
								str = str.substring(1,str.length());
						
							//und pruefen , ob gueltige Zahl bzw. >= 2
							BigInteger base = new BigInteger(str , 10);
							
							if (base.compareTo(BigInteger.valueOf(2)) < 0)
								throw new NumberFormatException("only accepting positive integers >= 2");
							
							//alles ok? , dann Horner-Schema
							HornerScheme(n , base);
						}
						catch (NumberFormatException error)
						{
							output.setText("Error in Base : "+error.getMessage());
						}

					}
					catch (NumberFormatException error)
					{
						output.setText("Error in Number : "+error.getMessage());
					}
				}
			}
		};
		button.addActionListener(action);

	}


	
	public void start()
	{	repaint();	}
	
	public void run()
	{	repaint();	}
	
	public void paint(Graphics g)
	{
	}
	
	public void destroy()
	{
	}
}