import java.applet.*;
import java.awt.*;
import java.awt.event.*;


public class aufgabe_1_2 extends Applet
{
	TextArea	input_str = new TextArea("PME SDGZPXQSQZPQ BDANXQY PQD WAYYGZUWMFUAZ NQEFQTF PMDUZ QUZQ ZMOTDUOTF IUQPQDLGSQNQZ, PUQ MZ MZPQDQD EFQXXQ SQEQZPQF IGDPQ." , 2 , 40 , TextArea.SCROLLBARS_VERTICAL_ONLY);;
	TextField	input_key = new TextField("12" , 5);
	TextArea	output_str = new TextArea("" , 2 , 40 , TextArea.SCROLLBARS_VERTICAL_ONLY);

	void	Encode(String str , int key)
	{
		int	i;
		char	c;
		String	outp = "";
		str.toUpperCase();
		
		key = key % 26;
		
		for (i=0; i<str.length(); i++)
		{
			if ( (str.charAt(i)>='A') && (str.charAt(i)<='Z') )
			{
				c = (char)(str.charAt(i)+key);
				//zyklische Verschiebung
				if (c>'Z')
					c=(char)('A'+(c-'Z'-1));
			}
			else
				c=str.charAt(i);
			outp += c;
		}
		output_str.setText(outp);
	}
	
	void	Decode(String str , int key)
	{
		int	i;
		char	c;
		String	outp = "";
		str.toUpperCase();
		
		key = key % 26;
		
		for (i=0; i<str.length(); i++)
		{
			if ( (str.charAt(i)>='A') && (str.charAt(i)<='Z') )
			{
				c = (char)(str.charAt(i)-key);
				//zyklische Verschiebung
				if (c<'A')
					c=(char)('Z'-('A'-c-1));
			}
			else
				c=str.charAt(i);
			outp += c;
		}
		output_str.setText(outp);
	}
	
	public void init()
	{
		setFont(new Font("Courier" , Font.BOLD , 12));
		
		Button		encode = new Button("Encode");
		encode.setActionCommand("Encode");
		Button		decode = new Button("Decode");
		decode.setActionCommand("Decode");
		
		Panel	panel = new Panel();
		panel.setLayout(new GridLayout(3,2));
		panel.add(new Label("Key : "));
		panel.add(input_key);
		panel.add(encode);
		panel.add(decode);
		panel.add(new Label("Output String :"));
		
		setLayout(new GridLayout(4,1));
		
		add(new Label("Input String : "));
		add(input_str);
		add(panel);
		add(output_str);
		
		ActionListener action = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String	cmd = e.getActionCommand();
				String	str;
				int		key;
				
				if (cmd == "Encode")
				{
					str = input_str.getText();
					cmd = input_key.getText();
					if (cmd.charAt(0) == '+')
						cmd = cmd.substring(1,cmd.length());
					try
					{
						key = Integer.parseInt(cmd);
						Encode(str , key);
					}
					catch (NumberFormatException error)
					{
						output_str.setText("Error : "+error.getMessage());
					}
				}
				
				if (cmd == "Decode")
				{
					str = input_str.getText();
					cmd = input_key.getText();
					if (cmd.charAt(0) == '+')
						cmd = cmd.substring(1,cmd.length());
					try
					{
						key = Integer.parseInt(cmd);
						Decode(str , key);
					}
					catch (NumberFormatException error)
					{
						output_str.setText("Error : "+error.getMessage());
					}
				}
			}
		};
		
		encode.addActionListener(action);
		decode.addActionListener(action);
	}
	
	public void start()
	{	repaint();	}
	
	public void run()
	{	repaint();	}
	
	public void paint(Graphics g)
	{
	}
	
	public void destroy()
	{
	}
}